/*==============================================================================================
       COM_PORT2     .
    .         
COM_PORT1
==============================================================================================*/

#define F_CPU 14745600UL																				/*   */

#define COM_RX_BUFFER_SIZE 256 																			/*   256 */
#define COM_TX_BUFFER_SIZE 256																			/*   256 */
#define COM1_PROTOCOL MODBUS																			/*  COM1-   Modbus RTU*/
#define COM2_PROTOCOL MODBUS																			/*  COM2-   Modbus RTU*/

#define TIMER2																							/*      2  LED.h*/
#define SLAVE_COM1 ON																					/*  COM1   SLAVE*/

#include <util/delay.h>																					/*   */
#include <avr/io.h>																						/*   / ( )*/

#include <stdio.h>																						/*      */

#include "MC8U8O.h"																						/*   */

#include "LED.h"																						/*    */
#include "COM.h"																						/*    COM-  
																										 DCON  Modbus RTU*/
#include "COM_SLAVE.h"																					/*    Modbus RTU*/
#include "Key.h"																						/*     */

volatile uint16_t timer_s = 0;																			/* */
char Amount[2] = {0x00,0x02};																			/*   -  0x0002*/

ISR(TIMER0_COMP_vect) {																					/*  0*/
	timer_s++;																							/*    1  timer_s*/
}

void Timer0_Enable(void)																				/*    0*/
{
	OCR0 = F_CPU*0.001/1024+0.5;																		//  1 
	TIMSK |=(1<<OCIE0);																					//     0
	TCCR0 =(1<<WGM01)|(1<<CS02)|(1<<CS00);																/*  0   "  ".*/
	sei();																								//  
}

int main(void){	
	_delay_ms(1000);																					/*   */
	LED_Init();																							/* */
	Timer0_Enable();																					/* */
																				
	char message[32];																					/*      COM_PORT2( : id, , -)*/																					
	char message2[32];																					/*      COM_PORT2( :  )*/	

	char RX_Buf2[250];																					/*    */
	char* current_slave = &RX_Buf2[1];																	/*   */

	uint16_t value_reg;																					/*      */
	uint16_t value_reg1;																				/*      */

	COM_Init(COM_PORT1, 9600);																			/* COM1 */
	COM_Init(COM_PORT2, 9600);																			/* COM2 */
	
	while(1)
	{	
			if (timer_s > 500){
				Write_Request_Modbus(COM_PORT2,0x01,0x04,0001,Amount,4);								/*      */
				Led(LD_SW);																				/* */
				timer_s = 0;																			/* */
			}
			
		 
		if (Read_Modbus(COM_PORT2,RX_Buf2) == 1){														/*   */
			value_reg = ((uint16_t)current_slave[3]<<8) | (current_slave[4] & 0xFF);					/* */
			value_reg1 = ((uint16_t)current_slave[5]<<8) | (current_slave[6] & 0xFF);
			Write_INPUT_REGISTER(COM_PORT1,0,value_reg);													/*   input register*/
			Write_INPUT_REGISTER(COM_PORT1,1,value_reg1);													/*   input register*/
			
			sprintf(message,"%u %u %u",current_slave[0],current_slave[1],current_slave[2]);				/*  (   : id, , -*/
			LED_SetPos(0,0);																			/*   */
			LED_Write_String(message);																	/*    */
			sprintf(message2,"%u - %u",value_reg,value_reg1);											/*  (   :  */
			LED_SetPos(1,0);																			/*   */																	
			LED_Write_String(message2);																	/*    */
		}	
	}
}

